//@LibraryID:150,1
//@LibraryID:150,0
//@Name:Portfolio Optimisation
//@Description:Creates a correlation matrix in a spreadsheet for Markowitz mean-variance portfolio optimisation 
//@Returns:Number
//@Width:80
//@Env:Production

// Created by Rene Alby (ShareScope Support) Tel: 0845 045 0111 / 020 7549 1104 
// Care has been taken in preparing this code but it is provided without guarantee.
// You are welcome to modify and extend it.  Please add your name as a modifier if you distribute it.

var createReport = 0;
var PeriodType = 0;
var NumOfPeriods = 52;
var OutputType = 0
var dataList = getPortfolioNames();
var portfolioShares = 0;
var DL = 0;
var index = 0;
var data = 0;
var prices = 0;
//var hpr = new Array;
var avg = new Array;
var periodList = ["Weekly","Monthly","Daily"];
var OutputList = ["EPIC","Name"];

function main()
{
	clear();
	load("libraries\\SSLib.ssl");
		dlg = new Dialog("Select Portfolio", 160, 85);
		dlg.addHelpButton(getScriptPath()+"Portfolio Optimisation.html")
		//dlg.addHelpButton("Portfolio Optimisation.html")
		dlg.addOkButton(-1,-1,-1,-1,"Finish");
		dlg.addCancelButton();
		dlg.addDropList("Int1",8,-1,80,-1,dataList,"","",DL); //DL is storage, datalist = list, datasource = default value
		dlg.addDropList("Int2",8,-1,80,-1, periodList,"","",PeriodType);
		dlg.addDropList("Int4",8,-1,80,-1, OutputList,"","",OutputType);
		dlg.addIntEdit("Int3", 60, -1, -1, -1, "Periods", "",NumOfPeriods);
		dlg.addTickBox("Int5",10,-1,100,-1,"Generate report",createReport);
		if (dlg.show()==Dialog.Cancel)
			return false;
		DL = dlg.getValue("Int1");
		PeriodType = dlg.getValue("Int2");
		NumOfPeriods = dlg.getValue("Int3");
		OutputType = dlg.getValue("Int4");
		createReport = dlg.getValue("Int5");
		
		portfolioShares = getPortfolio(dataList[DL]);
	
	var hpr = [];
	var negReturns = []; //for sortino ratio
	var downsideDeviation = []
	var avg = [];
	var avg2 = [];
	var er = [];
	var weight = [];
	var sortino = [];
	var deviations = [];
	var SSDeviations = [];
	var variance = [];
	var stdev = [];
	var portfolioVariance = 0;
	var corrMatrix = [];
	var epicString = "";
	var weightString = "WEIGHT:,";
	var erString = "ANNUALISED EXPECTED RETURN:,";
	var varianceString = "VARIANCE:,";
	var stdevString = "ANNUALISED ST-DEV:,";
	var sortinoString = "ANNUALISED SORTINO RATIO:,";
	var reportString = "";
	var excel = ['b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','aa','ab','ac','ad','ae','af','ag','ah','ai','aj','ak','al','am','an','ao','ap','aq','ar','as','at','au','av','aw','ax','ay','az','ba','bb','bc','bd','be','bf','bg','bh','bi','bj','bk','bl','bm','bn','bo','bp','bq','br','bs','bt','bu','bv','bw','bx','by','bz','ca','cb','cc','cd','ce','cf','cg','ch','ci','cj','ck','cl','cm','cn','co','cp','cq','cr','cs','ct','cu','cv','cw','cx','cy','cz','da','db','dc','dd','de','df','dg','dh','di','dj','dk','dl','dm','dn','do','dp','dq','dr','ds','dt','du','dv','dw','dx','dy','dz','ea','eb','ec','ed','ee','ef','eg','eh','ei','ej','ek','el','em','en','eo','ep','eq','er','es','et','eu','ev','ew','ex','ey','ez','fa','fb','fc','fd','fe','ff','fg','fh','fi','fj','fk','fl','fm','fn','fo','fp','fq','fr','fs','ft','fu','fv','fw','fx','fy','fz','ga']
	var matchDates = [];
	
	var getCalc = "=";
	load("Libraries\\SSLib.ssl");

	//For annualising data
	var pers = 0;
	if (PeriodType == 0) pers = 52; 
	if (PeriodType == 1) pers = 12; 
	if (PeriodType == 2) pers = 255; 

	
	var prices2 = 0;
	var DS = false;
	var DS_Output = "The following items have insufficient history for specified period length: ";
	var maxPeriods = 999999999; //set arbitrary large value
	var integrity = [];
	
	for (t2 = 0; t2 <= portfolioShares.length - 1; t2++) //Test data for sufficiency.
		{
			if (PeriodType == 0) prices2 = portfolioShares[t2].getWeeklyBarArray();
			if (PeriodType == 1) prices2 = portfolioShares[t2].getMonthlyBarArray();
			if (PeriodType == 2) prices2 = portfolioShares[t2].getPriceArray();
			if (prices2.length < maxPeriods) maxPeriods = prices2.length - 3; //Searches for the maximum value available for 'periods' variabe
			if (prices2.length - 3 < NumOfPeriods) //Tests whether the history available exceeds the specified number of periods
				{
				DS = true;
				DS_Output += portfolioShares[t2].getName()+", ";
				}	
		prices2.reverse()
		integrity[t2] = prices2[NumOfPeriods].date //Stores dates for last price point in array
		}

	for (t3 = 0; t3 <= portfolioShares.length - 1; t3++) //Checks if dates match (only applicable to daily series)
		{
			if (t3 < portfolioShares.length - 1) integrity[t3+1] -= 0  //This converts the date objest into a number variable
			integrity[t3] -= 0 //Same as above (For comparison to work)
			if (t3 < portfolioShares.length - 1)
			{
				if (integrity[t3+1] != integrity[t3])
				{	
				print (integrity[t3+1]+" "+integrity[t3]);
				print ("The dates for "+portfolioShares[t3+1].getName()+" do not match the dates for "+portfolioShares[t3].getName());
				print ("this can be caused by mixing shares that trade on different markets in different countries with different holidays");
				print ("to correct this, either switch to weekly or monthly data, or remove the share with the inconsistant dates");
				return false;
				}
			}
		}
		
		if (DS == true)
		{
			print ("");
			print (DS_Output);
			return false;
		}

		for (t = 0; t <= portfolioShares.length - 1; t++) //cycles through each share in the portfolio.
		{

		if (PeriodType == 0) prices = portfolioShares[t].getWeeklyBarArray();
		if (PeriodType == 1) prices = portfolioShares[t].getMonthlyBarArray();
		if (PeriodType == 2) prices = portfolioShares[t].getPriceArray();

		prices.reverse(); // For my own sanity	
		if (prices.length>NumOfPeriods+3) prices.length=NumOfPeriods+3;  
		hpr[t] = [];
		negReturns[t] = [];
		deviations[t] = [];
		corrMatrix[t] = [];
		avg[t] = 0;  //Sets the type as a number
		downsideDeviation[t] = 0;  //Sets the type as a number
		er[t] = 1;
		var counter = 0;
		var counter2 = 0

		
		
		for (m = 2; m < prices.length; m++)
		{
			
				hpr[t][counter] = ((prices[m-1].close - prices[m].close)/prices[m].close); //Calculated the holding period return
				
				
				//hpr[t][counter] = Math.log((prices[m-1].close)/(prices[m].close)); //Continuously Compounded return (LOG RETURN) only for ST-dev
				
				//FOR Debugging returns and prices
				//print (hpr[t][counter]+","+prices[m-1].close+","+prices[m].close+","+portfolioShares[t].getEPIC());
				
				if (hpr[t][counter] < 0) 
					{
					negReturns[t][counter2] = hpr[t][counter];
					downsideDeviation[t] += Math.pow(negReturns[t][counter2], 2);  //Sums the squared negative returns for sortino			
					}
				er[t] *= (1+((prices[m-1].close - prices[m].close)/prices[m].close));  //Calculated the expected return
			//	if (OutputType == 0) print (portfolioShares[t].getEPIC()+" "+prices[m].close+" "+prices[m-1].close); 
			//		else if (OutputType == 1) print (portfolioShares[t].getName()+" "+prices[m].close+" "+prices[m-1].close);
					counter += 1;
					counter2 += 1;
				avg[t] += ((prices[m-1].close - prices[m].close)/prices[m].close);  //Sums returns				
		}



		avg[t] = (avg[t]/(counter)); //Averages returns
		downsideDeviation[t] = Math.pow((downsideDeviation[t]/(counter)), 0.5); //downsideDeviation for sortino must be divided by all observations (counter), not just negative observations
			
		SSDeviations[t] = 0;
		for (q = 0; q < counter; q++)
		{
			deviations[t][q] = ((hpr[t][q])-avg[t]); //remember t refers to each share in the portfolio
			SSDeviations[t] += Math.pow(deviations[t][q],2); //Sum of Squared Deviations			
		}
		
	weight[t] = (1/portfolioShares.length);  // Stores equal weighting for each share in portfolio.

	if (PeriodType == 0) er[t] = Math.pow(er[t], (52/(counter))); //Annualizing the expected return figures
	if (PeriodType == 1) er[t] = Math.pow(er[t], (12)/(counter));
	if (PeriodType == 2) er[t] = Math.pow(er[t], (255)/(counter));

	er[t] = er[t] - 1; //removes the 1 added to Expected Return array - Must go after the annualizing.
	
	variance[t] = SSDeviations[t]/(counter-1);
	stdev[t] = Math.pow(variance[t],0.5);
	if (PeriodType == 0) sortino[t] = (er[t]/(downsideDeviation[t]*Math.pow(52, 0.5)));//Take compound (geometric) return divided by dowside deviation and annualize Sortino ratio
	if (PeriodType == 1) sortino[t] = (er[t]/(downsideDeviation[t]*Math.pow(12, 0.5)));
	if (PeriodType == 2) sortino[t] = (er[t]/(downsideDeviation[t]*Math.pow(255, 0.5)));
	}
	
var stringX = "";

	for (wh = 0; wh < portfolioShares.length; wh++) //creates strings to output to the excel file
	{
	if (OutputType == 0) epicString += portfolioShares[wh].getEPIC()+",";
		else if (OutputType == 1) epicString += portfolioShares[wh].getName()+",";
	weightString += weight[wh]+",";
	erString += er[wh]+",";
	varianceString += variance[wh]+",";
	//stdevString += stdev[wh]+",";
	sortinoString += sortino[wh]+",";
	if (PeriodType == 0) stdevString += (stdev[wh]*Math.pow(52,0.5))+","; //Annualize the weekly Standard Deviation
	if (PeriodType == 1) stdevString += (stdev[wh]*Math.pow(12,0.5))+","; //Annualize the Monthly Standard Deviation
	if (PeriodType == 2) stdevString += (stdev[wh]*Math.pow(255,0.5))+","; //Annualize the Daily Standard Deviation
	
	//Debugging
	//print (portfolioShares[wh].getEPIC()+" : "+er[wh]+" / "+downsideDeviation[wh]+" annualized = "+downsideDeviation[wh]*Math.pow(52,0.5)+" = "+sortino[wh]);

	}

var portER = "";
for (f = 0; f <= portfolioShares.length - 1; f++)  
{
	portER += excel[f]+"2*"+excel[f]+"3+";
}
portER = portER.substring(0,portER.length - 1);//removes the last + from the string (the calculation)

//Creates the excel file and outputs the data to the file	
var barFile = new File();
barFile.open("Data.csv",File.WriteMode);
barFile.writeLine(","+epicString);	
barFile.writeLine(weightString+",SUM OF WEIGHTS:,=SUM(B2:"+excel[portfolioShares.length - 1]+"2),ANNUALISED PORTFOLIO ST-DEV:,=sqrt(B"+(2*portfolioShares.length+13)+")");
barFile.writeLine(erString+",PORTFOLIO EXPECTED RETURN:,="+portER+",RISK FREE RATE:,0.02");
barFile.writeLine(varianceString+",ANNUALISED PORTFOLIO VARIANCE:,=(B"+(2*portfolioShares.length+13)+"),SHARPE RATIO:,=("+excel[portfolioShares.length+2]+"3-"+excel[portfolioShares.length+4]+"3)/"+excel[portfolioShares.length+4]+"2");
barFile.writeLine(stdevString+",,,ANNUALISED SORTINO RATIO:,="+excel[portfolioShares.length+3]+""+((2*portfolioShares.length)+(prices.length)+18));
barFile.writeLine(sortinoString);	
barFile.writeLine("");
barFile.writeLine("CORRELATION MATRIX:");
barFile.writeLine(","+epicString);	

if (createReport == 1)  //creates the report file
	{	
	var reportFile = new File();
	reportFile.open("Report.csv",File.WriteMode);
	reportFile.writeLine("Name, Correlated to, Correlation, Sector, Expected return, Variance, Sortino Ratio, Standard Deviation");
	}
	
var strs = "";
	if (PeriodType == 0) print("Sample of "+counter+" Weeks, out of a maximum of "+maxPeriods+" for this portfolio");
	if (PeriodType == 1) print("Sample of "+counter+" Months, out of a maximum of "+maxPeriods+" for this portfolio");
	if (PeriodType == 2) print("Sample of "+counter+" Days, out of a maximum of "+maxPeriods+" for this portfolio");
	print ("");
	print ("Correlation Matrix: ");
	print ("------------------");
		for (a = 0; a <= portfolioShares.length - 1; a++)  
		{
		if (OutputType == 0) stringX = portfolioShares[a].getEPIC()+",";
			if (OutputType == 1) stringX = portfolioShares[a].getName()+",";
			for (b = 0; b <= portfolioShares.length - 1; b++)
			{
				corrMatrix[a][b] = 0;
				for (c = 0; c < counter ; c++)
				{
					corrMatrix[a][b] += (deviations[a][c] * deviations[b][c]);  //Summation of the product of each shares deviation from the mean
				}
			corrMatrix[a][b] = ((corrMatrix[a][b] / (counter - 1))/(stdev[a] * stdev[b])); //Converts summed deviations into correlation (COVAR/STDEV(A&B))
			stringX += corrMatrix[a][b].toFixed(4)+","; //Creates a string with the values of the correlation matrix
			
			if (createReport == 1)
				{
				//Generate Report
				reportString = portfolioShares[a].getName()+","+portfolioShares[b].getName()+","+corrMatrix[a][b].toFixed(4)+","+portfolioShares[a].getSector()+","+er[a]+","+variance[a].toFixed(5);
				
				//Add sortino ratio to output
				if (PeriodType == 0) reportString += ","+(er[a]/(downsideDeviation[a]*Math.pow(52, 0.5))).toFixed(5);
				if (PeriodType == 1) reportString += ","+(er[a]/(downsideDeviation[a]*Math.pow(12, 0.5))).toFixed(5);
				if (PeriodType == 2) reportString += ","+(er[a]/(downsideDeviation[a]*Math.pow(255, 0.5))).toFixed(5);
				
				//Add Standard Deviation to output
				if (PeriodType == 0) reportString += ","+(stdev[a]*Math.pow(52,0.5)).toFixed(5)+","; 
				if (PeriodType == 1) reportString += ","+(stdev[a]*Math.pow(12,0.5)).toFixed(5)+","; 
				if (PeriodType == 2) reportString += ","+(stdev[a]*Math.pow(255,0.5)).toFixed(5)+","; 

				reportFile.writeLine(reportString);		
				}	
			}
		barFile.writeLine(stringX);
		
		print (stringX); //Prints each row of the correlation matrix
		stringX = ""; // resets the string
		}

		
		//Outputs individual variances into a matrix for portfolio variance calculation
		var varString = "";
		var numToString = 0;
		barFile.writeLine("");		
		barFile.writeLine("ANNUALISED PORTFOLIO VARIANCE CALCULATION");		
		for (d = 0; d <= portfolioShares.length - 1; d++) 
		{		
			for (e = 0; e <= portfolioShares.length - 1; e++)
			{
			portfolioVariance += ((weight[d] * weight[e] * stdev[d] * stdev[e] * corrMatrix[d][e]));  //Calculates the portfolio variance and outputs to file
			varString +=("=("+excel[d]+"2*"+""+excel[e]+"2*"+excel[d]+"5*"+excel[e]+"5*"+excel[e]+(d+10)+"),");
			}
			barFile.writeLine(varString);
			varString = "";
		}
		barFile.writeLine("");
		numToString = (portfolioShares.length)+12 //Workaround for issue with numbers being converted to strings
		barFile.writeLine("Annualised Portfolio Variance:,=sum(A"+(portfolioShares.length+12)+":"+excel[portfolioShares.length-2]+""+((2*portfolioShares.length)+11)+")"); //Calculates the position of the cell

		
		//outputs portfolio periodic returns based on weights
		barFile.writeLine("");		
		barFile.writeLine("PORTFOLIO PERIODIC RETURNS");		
		barFile.writeLine("");		
		barFile.writeLine(","+epicString+",PORTFOLIO RETURN,DOWNSIDE DEVIATIONS,,% RETURN + 1, 100");		
		var hprString = ""
		var portReturnString = ",=("
		var commaString =",,,";
	
		for (mm = 0; mm < prices.length-2; mm++)
			{
			for (tt = 0; tt <= portfolioShares.length - 1; tt++)
				{
				hprString += ("="+hpr[tt][mm]+",");
				}
			for (ttt = 0; ttt <= portfolioShares.length - 1; ttt++)
				{
					portReturnString += excel[ttt]+(2*portfolioShares.length+18+mm)+"*"+excel[ttt]+"2+";
				}
			portReturnString = portReturnString.substring(0,portReturnString.length - 1);
			barFile.writeLine(","+hprString+portReturnString+"),\"=if("+excel[portfolioShares.length+1]+(2*portfolioShares.length+18+mm)+"<0,"+excel[portfolioShares.length+1]+(2*portfolioShares.length+18+mm)+",0)\",="+excel[portfolioShares.length+2]+(2*portfolioShares.length+18+mm)+"^2,="+excel[portfolioShares.length+1]+(2*portfolioShares.length+18+mm)+"+1,="+excel[portfolioShares.length+4]+(2*portfolioShares.length+18+mm)+"*"+excel[portfolioShares.length+5]+(2*portfolioShares.length+17+mm));
			portReturnString =",=(";  //Resets string
			hprString = ""; //resets string
			}

		for (q = 0; q <= portfolioShares.length - 1; q++) //creates a string of commas for positioning
			{
			commaString += ","; 
			}
		
		barFile.writeLine("");
		var downsideDevString = (commaString+"Downside Deviation,=(sum("+excel[portfolioShares.length+3]+""+((2*portfolioShares.length)+18)+":"+excel[portfolioShares.length+3]+""+((2*portfolioShares.length)+(prices.length)+15)+")/count("+excel[portfolioShares.length+3]+""+((2*portfolioShares.length)+18)+":"+excel[portfolioShares.length+3]+""+((2*portfolioShares.length)+(prices.length)+15)+"))");
		if (PeriodType == 0) downsideDevString += "*sqrt(52)";
		if (PeriodType == 1) downsideDevString += "*sqrt(12)";
		if (PeriodType == 2) downsideDevString += "*sqrt(255)";
		barFile.writeLine(downsideDevString);
		barFile.writeLine(commaString+"Sortino Ratio,="+excel[portfolioShares.length+2]+"3/"+excel[portfolioShares.length+3]+""+((2*portfolioShares.length)+(prices.length)+17));
		print ("");
		print ("An excel file has now been created: Data.csv");
		if (createReport == 1) print ("A report file has been created: Report.csv");
		print ("It is located in the main program folder > 'ShareScript' > 'Output'");

		barFile.close;
		if (createReport == 1) reportFile.close;
		}		//print("Portfolio Variance:,=sum(A"+portfolioShares.length+12+":"+excel[portfolioShares.length-1]+(numToString)+")"); //Calculates the position of the cell
			